#include <amxmodx>
#include <amxmisc>

#if AMXX_VERSION_NUM < 183
	#include <colorchat>
	#include <dhudmessage>
#endif

#define PLUGIN "TOP VIP (Auto Set)"
#define VERSION "2.0"
#define AUTHOR "Leo_[BH] & maFFyoZZyk"

#define STATS_OPTIONS 1
	// 0 - CSX
	// 1 - CSSTATSX SQL by serfreeman1337
	// 2 - CSSTATS MYSQL by SKAJIbnEJIb
#if STATS_OPTIONS == 0
	native get_user_stats(index,stats[8],bodyhits[8]);
#endif
#if STATS_OPTIONS == 1
	native get_user_stats_sql(index, stats[8], bodyhits[8]);
#endif
#if STATS_OPTIONS == 2
	native csstats_get_user_place(id);
#endif

#if !defined MAX_PLAYERS
	const MAX_PLAYERS = 32;
#endif

new g_Flags_Vip, g_Top_Num, g_Chat_Enable, g_Hud_Enable, g_Sound_Enable
new irank

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	g_Flags_Vip			= register_cvar("amx_top_vip_access",			"t")
	g_Top_Num			= register_cvar("amx_top_vip_players",			"10")
	g_Chat_Enable		= register_cvar("amx_top_vip_chat_msg",			"1")
	g_Hud_Enable		= register_cvar("amx_top_vip_hud_msg",			"1")
	g_Sound_Enable		= register_cvar("amx_top_vip_sound",			"1")	
	register_cvar("amx_top_vip_task", "15.0")	
	register_clcmd("say /rank", 	"CmdRank");
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	
	return PLUGIN_CONTINUE;
}

public plugin_cfg(){
	new configsdir[128]
	get_localinfo("amxx_configsdir", configsdir, 127)
	return server_cmd("exec %s/top_vip.cfg", configsdir)
}

public client_putinserver(id)
{
	new Float:g_szSetTime = get_cvar_float("amx_top_vip_task")
	set_task(g_szSetTime, "csx_check", id)
}

public csx_check(id)
{
	if(!is_user_connected(id) || is_user_admin(id))	return PLUGIN_CONTINUE;
	
	UTIL_Chek_Rank(id);
	if (irank <= get_pcvar_num(g_Top_Num)) set_vip(id);
	
	return PLUGIN_CONTINUE;
}

public set_vip(id)
{
	if(!is_user_connected(id))	return PLUGIN_CONTINUE;

	new g_szFlagsVip[64]
	get_pcvar_string( g_Flags_Vip, g_szFlagsVip, 63 );
	
	new r_flag_z, flags_vip;	
	r_flag_z = read_flags("z");
	remove_user_flags(id,r_flag_z);
	
	flags_vip = read_flags(g_szFlagsVip);
	set_user_flags(id,flags_vip);
	UTIL_Chek_Rank(id);
	
	if(get_pcvar_num(g_Chat_Enable))	client_print_color(id, -2, "^1[^4STATS^1] Вы награждены ^4VIP-Привилегиями^1 за^3 %d-ое место^4 в топе сервера!", irank);	
	if(get_pcvar_num(g_Hud_Enable))
	{
		set_dhudmessage(0, 200, 0, -1.0, 0.28, 2, 6.0, 2.5, 0.05, 1.5);
		show_dhudmessage(id, "Вы награждены VIP-Привилегиями ^nЗа %d-ое место в топе сервера!", irank);
	}	
	if(get_pcvar_num(g_Sound_Enable))	client_cmd(id, "spk doop");
	
	return PLUGIN_CONTINUE;
}

public event_round_start() 
{
	new iPlayers[MAX_PLAYERS], iPlayersNum;
	get_players(iPlayers, iPlayersNum, "ch");

	for(new id; id < iPlayersNum; id++)
	{
		if(is_user_admin(iPlayers[id]))	return PLUGIN_CONTINUE;		
		
		UTIL_Chek_Rank(iPlayers[id]);		
		if (irank <= get_pcvar_num(g_Top_Num))	set_vip(id);
	}
	
	return PLUGIN_CONTINUE;
}

public CmdRank(id)
{
	new topnum = get_pcvar_num(g_Top_Num)
	
	if(get_pcvar_num(g_Hud_Enable))
	{
		set_dhudmessage(0, 200, 0, -1.0, 0.28, 2, 6.0, 2.5, 0.05, 1.5);		
		if(topnum == 1)	show_dhudmessage(id, "За первое место:^n VIP Выдается автоматически!");
		else if(topnum <= 4)	show_dhudmessage(id, "За первые %d места:^n VIP Выдается автоматически!", topnum);
		else	show_dhudmessage(id, "За первые %d мест:^n VIP Выдается автоматически!", topnum);
	}
	
	if(get_pcvar_num(g_Chat_Enable))
	{
		if(topnum == 1)	client_print_color(id, -2, "^1[^4STATS^1] За первое^3 %d ^1мест: ^4VIP бесплатно!")
		else if(topnum <= 4)	client_print_color(id, -2, "^1[^4STATS^1] За первые^3 %d ^1места: ^4VIP бесплатно!", topnum)
		else	client_print_color(id, -2, "^1[^4STATS^1] За первые^3 %d ^1мест: ^4VIP бесплатно!", topnum)
	}	
	return PLUGIN_CONTINUE;
}

UTIL_Chek_Rank(id)
{
#if STATS_OPTIONS == 0 || STATS_OPTIONS == 1
	new stats[8],bodyhits[8]
#endif
#if STATS_OPTIONS == 0
	irank = get_user_stats(id,stats,bodyhits);
#endif
#if STATS_OPTIONS == 1
	irank = get_user_stats_sql(id, stats, bodyhits);
#endif
#if STATS_OPTIONS == 2
	irank = csstats_get_user_place(id);
#endif
}